//
//  Copyright (C) 1994-2003  Seth Kurtzberg
//
// CQL++ This program is free software.  The copyright is reserved.
//
// The file COPYING included with the distribution specifies the license
// granted to users of CQL++.  You can also view the licensing terms
// at http://www.cql.com/copying.html
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See COPYING
// for more information
//
// If you did not receive the file COPYING which contains the terms of
// the license, and you do not have access to the world wide web, you
// can request a copy by the following email address:  support@cql.com.
// If you do not have access to email, you can obtain a copy by postal
// mail by writing to Machine Independent Software Corporation,
// 9663 East Voltaire Drive, Scottsdale, Arizona, 85260, USA
//


#include "CqlCommonInclude.h"


CharUCValue::CharUCValue( const CharUCValue& other ) : CharValue( other )
{
}


CharUCValue::CharUCValue( const CqlColumnTypes& ctype )
{
	value_.setString( ctype.typeLength() );
}


CharUCValue::CharUCValue( pUC& source ) : CharValue( source )
{
}


CharUCValue::CharUCValue( const NC *source ) : CharValue( source )
{
}


CharUCValue::CharUCValue( const CharValue& source ) : CharValue( source )
{
}


CharUCValue::CharUCValue( const CqlString& source ) : CharValue( source )
{
}


CharUCValue::CharUCValue( const NC source ) : CharValue( source )
{
}


CharUCValue::CharUCValue( const D source ) : CharValue( source )
{
}


CharUCValue::CharUCValue( const NI source ) : CharValue( source )
{
}


CharUCValue::CharUCValue( const UC *source ) : CharValue( source )
{
}


CharUCValue::CharUCValue( const UNI source ) : CharValue( source )
{
}


CharUCValue::CharUCValue( const US source ) : CharValue( source )
{
}


CharUCValue::CharUCValue( const UL source ) : CharValue( source )
{
}


NC CharUCValue::asChar() const
{
	throw IllegalTypeConversionException( __FILE__, __LINE__ );

#if defined( _MSC_VER ) && _MSC_VER != 1200
	// for dumb compilers
	return 0;
#endif
}


S CharUCValue::asShort() const
{
	throw IllegalTypeConversionException( __FILE__, __LINE__ );

#if defined( _MSC_VER ) && _MSC_VER != 1200
	// for dumb compilers
	return 0;
#endif
}


L CharUCValue::asLong() const
{
	throw IllegalTypeConversionException( __FILE__, __LINE__ );

#if defined( _MSC_VER ) && _MSC_VER != 1200
 	// for dumb compilers
	return 0;
#endif
}


BigintValue CharUCValue::asBigintValue() const
{
	throw IllegalTypeConversionException( __FILE__, __LINE__ );

#if defined( _MSC_VER ) && _MSC_VER != 1200
	// for dumb compilers
	return BigintValue();
#endif
}


DecimalValue CharUCValue::asDecimalValue() const
{
	throw IllegalTypeConversionException( __FILE__, __LINE__ );

#if defined( _MSC_VER ) && _MSC_VER != 1200
	// for dumb compilers
	return DecimalValue();
#endif
}


F CharUCValue::asFloat() const
{
	throw IllegalTypeConversionException( __FILE__, __LINE__ );

#if defined( _MSC_VER ) && _MSC_VER != 1200
	// for dumb compilers
	return 0;
#endif
}


D CharUCValue::asDouble() const
{
	throw IllegalTypeConversionException( __FILE__, __LINE__ );

#if defined( _MSC_VER ) && _MSC_VER != 1200
	// for dumb compilers
	return 0;
#endif
}


DateValue CharUCValue::asDateValue() const
{
	//  temporary
	throw IllegalTypeConversionException( __FILE__, __LINE__ );
#if defined( _MSC_VER ) && _MSC_VER != 1200
	return DateValue();
#endif
}


TimeValue CharUCValue::asTimeValue() const
{
	//  temporary
	throw IllegalTypeConversionException( __FILE__, __LINE__ );
#if defined( _MSC_VER ) && _MSC_VER != 1200
	return TimeValue();
#endif
}


TimestampValue CharUCValue::asTimestampValue() const
{
	//  temporary
	throw IllegalTypeConversionException( __FILE__, __LINE__ );
#if defined( _MSC_VER ) && _MSC_VER != 1200
	return TimestampValue();
#endif
}


bool CharUCValue::operator == ( const AbstractValue& other ) const
{
	return CharValue::operator == ( other );
}


bool CharUCValue::operator != ( const AbstractValue& other ) const
{
	return CharValue::operator != ( other );
}


bool CharUCValue::operator  > ( const AbstractValue& other ) const
{
	return CharValue::operator > ( other );
}


bool CharUCValue::operator >= ( const AbstractValue& other ) const
{
	return CharValue::operator >= ( other );
}


bool CharUCValue::operator < ( const AbstractValue& other ) const
{
	return CharValue::operator < ( other );
}


bool CharUCValue::operator <= ( const AbstractValue& other ) const
{
	return CharValue::operator <= ( other );
}


AbstractValue& CharUCValue::operator += ( AbstractValue& other )
{
	return CharValue::operator += ( other );
}


AbstractValue& CharUCValue::operator -= ( AbstractValue& other )
{
	return CharValue::operator -= ( other );
}


AbstractValue& CharUCValue::operator *= ( AbstractValue& other )
{
	return CharValue::operator *= ( other );
}


AbstractValue& CharUCValue::operator /= ( AbstractValue& other )
{
	return CharValue::operator /= ( other );
}


bool CharUCValue::operator ! ( void ) const
{
	return !value();
}
